Subject: bug#22510: 25.1.50; error in lm-header-multiline

From: John Kitchin <[email-masked]>
Date: Sun, 31 Jan 2016 17:56:12 -0500

I think there is a bug in lm-header-multiline in lisp-mnt.el.

It does not actually read multiline headers because in line 285, the
call to lm-header does not move point, and the subsequent code does not
read the next lines.

I do not see a good fix. One could modify the lm-header code or add the
code to lm-header-multiline. I am not sure of the implications of either
of these.

Here is my solution that returns single and multiline headers. I have
signed FSF papers, so you are welcome to this code if you like it.

thanks,

(defun lm-header (header)
  "Return the contents of the header named HEADER.
If the HEADER is multiline, a list of strings is returned."
  (save-excursion
    (goto-char (point-min))
    (let ((case-fold-search t)
          res)
      (when (and (re-search-forward
                  (lm-get-header-re header)
                  (lm-code-mark) t)
                 ;;   RCS ident likes format "$identifier: data$"
                 (looking-at
                  (if (save-excursion
                        (skip-chars-backward "^$" (match-beginning 0))
                        (= (point) (match-beginning 0)))
                      "[^\n]+" "[^$\n]+")))
        (setq res (list (match-string-no-properties 0)))
        (forward-line 1)
        (while (looking-at "^;+\\(\t\\|[\t\s]\\{2,\\}\\)\\(.+\\)")
          (push (match-string-no-properties 2) res)
          (forward-line 1))
        (setq res (nreverse res))
        (if (= 1 (length res))
            (car res)
          res)))))

--
Professor John Kitchin
Doherty Hall A207F
Department of Chemical Engineering
Carnegie Mellon University
Pittsburgh, PA 15213
412-268-7803
@johnkitchin
http://kitchingroup.cheme.cmu.edu